#include "dbg.h"

#ifdef DEBUG

#define MAXPTR 3000

void*	dbg_ptr_base[MAXPTR];
size_t	dbg_ptr_size[MAXPTR];
int		dbg_ptr_elt[MAXPTR];

int dbg_nb_ptr;
int dbg_cur_ptr;
int dbg_count;

void error(char*);

void dbg_init()
{
	dbg_nb_ptr = 0;
	dbg_cur_ptr = 0;
	dbg_count = MAXPTR;
	memset(dbg_ptr_base,sizeof(dbg_ptr_base),0);
}

void* dbg_malloc(size_t s,int c)
{
	void *p;
	if (dbg_count==0)
		error("OVERFLOW");
	p = malloc(s*c);
	if (p==NULL)
	{
		int i,sum=0;
		char buf[64];
		for (i=0;i<MAXPTR;i++)
			if (dbg_ptr_base[i])
				sum+=dbg_ptr_size[i];
		sprintf(buf,"MALLOC %d %d %d*%d=%d",dbg_count,sum,s,c,s*c);
		error(buf);
	}
	while(dbg_ptr_base[dbg_cur_ptr])
		dbg_cur_ptr++;
	dbg_ptr_base[dbg_cur_ptr] = p;
	dbg_ptr_size[dbg_cur_ptr] = s*c;
	dbg_ptr_elt[dbg_cur_ptr++]= s;
	dbg_count--;
	return p;
}

int dbg_index(void* p)
{
	int i;
	for (i=0;i<MAXPTR;i++)
		if (dbg_ptr_base[i]==p)
			return i;
	return -1;
}

void dbg_free(void* p)
{
	int i = dbg_index(p);
	if (i<0)
		error("FREE");
	dbg_ptr_base[i] = 0;
	free(p);
	dbg_count++;
}

int dbg_verify(void* p,int idx)
{
	int i = dbg_index(p);
	if (i<0 || (idx*dbg_ptr_elt[i])>=dbg_ptr_size[i])
		error("GET");
	return idx;
}

void dbg_memset(void *p,int v,size_t s)
{
	int i = dbg_index(p);
	if (i<0 || s>=dbg_ptr_size[i])
		error("MEMSET");
	memset(p,v,s);
}

#else

void dbg_init()
{
}

#endif
