#include <stdlib.h>

#ifndef DEBUG

#define MALLOC(s,c) malloc(s*c)
#define FREE(p) free(p)
#define GET(p,i) (p)[i]
#ifdef GP32
void asm_memset(void*,int,int);
#define MEMSET(p,v,s) asm_memset(p,v,s)
#else
#define MEMSET(p,v,s) memset(p,v,s)
#endif

#else

void*	dbg_malloc(size_t s,int c);
void	dbg_free(void* p);
int		dbg_verify(void*p,int idx);
void	dbg_memset(void *p,int v,size_t s);

#define MALLOC(s,c)		dbg_malloc(s,c)
#define FREE(p)			dbg_free(p)
#define GET(p,i)		p[dbg_verify(p,i)]
#define MEMSET(p,v,s)	dbg_memset(p,v,s)

#endif

void dbg_init(void);
