#include "o3d.h"

#define VERTEX(o,i,xi,yi,zi) VECTOR(o,i,vert,xi,yi,zi)

#define TRIANGLE(o,i,ai,bi,ci,ti,dti) \
	{ \
	(o)->tri[i].a			= (ai); \
	(o)->tri[i].b			= (bi); \
	(o)->tri[i].c			= (ci); \
    (o)->tri[i].d           = NOTSET; \
	(o)->tri[i].type		= (ti); \
	(o)->tri[i].data.data	= (dti); \
	}

#define TEXDATA(d,x0,y0,x1,y1,x2,y2,t) \
	{ \
	d->x[0] = x0; \
	d->x[1] = x1; \
	d->x[2] = x2; \
	d->y[0] = y0; \
	d->y[1] = y1; \
	d->y[2] = y2; \
	d->t    = t;  \
	}

#define QUAD(o,i,ai,bi,ci,di,ti,dti) \
    { \
    (o)->tri[i].a           = (ai); \
    (o)->tri[i].b           = (bi); \
    (o)->tri[i].c           = (ci); \
    (o)->tri[i].d           = (di); \
    (o)->tri[i].type        = (ti); \
    (o)->tri[i].data.data   = (dti); \
    }

#define QTEXDATA(d,x0,y0,x1,y1,x2,y2,x3,y3,t) \
    { \
    d->x[0] = x0; \
    d->x[1] = x1; \
    d->x[2] = x2; \
    d->x[3] = x3; \
    d->y[0] = y0; \
    d->y[1] = y1; \
    d->y[2] = y2; \
    d->y[3] = y3; \
    d->t    = t;  \
    }

OBJECT3D *o3d_createNewObject(int,int,int);

/* Using triangles */
OBJECT3D *o3d_createSprite(int,int,int,int,TEXTURE3D*,TRIANGLE3D_TYPE);
OBJECT3D *o3d_createColoredBox(int w,int h,int d,LCOLOR3D *col);
OBJECT3D *o3d_createTexturedBox(int w,int h,int d,int xt,int yt,int wt,int ht,TEXTURE3D* t,TRIANGLE3D_TYPE type);
OBJECT3D *o3d_createMixedBox(int w,int h,int d,LCOLOR3D *col,int xt,int yt,int wt,int ht,TEXTURE3D* t,TRIANGLE3D_TYPE type);
OBJECT3D *o3d_createTriangle(int s,LCOLOR3D *col);

/* Using quadrangles */
OBJECT3D *o3d_createSpriteQ(int x,int y,int w,int h,TEXTURE3D* t,TRIANGLE3D_TYPE type);
OBJECT3D *o3d_createColoredBoxQ(int w,int h,int d,LCOLOR3D *col);
OBJECT3D *o3d_createTexturedBoxQ(int w,int h,int d,int xt,int yt,int wt,int ht,TEXTURE3D* t,TRIANGLE3D_TYPE type);
OBJECT3D *o3d_createMixedBoxQ(int w,int h,int d,LCOLOR3D *col,int xt,int yt,int wt,int ht,TEXTURE3D* t,TRIANGLE3D_TYPE type);
OBJECT3D *o3d_createQuad(int s,LCOLOR3D *col);
