#ifndef _TABLES_H_
#define _TABLES_H_

#define PRECISION1 512
#define PRECISION2 256
#define MULT 1024
#define SHIFT 10
#define PMASK 511
#define DIV_MULT 524288
#define DIV_SHIFT 19
#define MAX_DIV 32767

#define DIVIDE(a,b) (DIVIDE_NS(a,b)>>DIV_SHIFT)
#define DIVIDE_NS(a,b) ((b)<0 ? (-(a)*tdiv[-(b)]) : ((a)*tdiv[b]))
#define DIVIDEP(a,b) (DIVIDE_NSP(a,b)>>DIV_SHIFT)
#define DIVIDE_NSP(a,b) ((a)*tdiv[b])

#ifndef _TABLES_C_
extern const int tsin[PRECISION1];
extern const int tcos[PRECISION1];
extern const int tdiv[MAX_DIV+1];
#endif

#endif
