#include "gp32.h"
//#include "fileio.h"
#include "smf_fat.h"
#include "zda.h"

#include "dbg.h"
#include "filezda.h"

#define BASEDIR "dev0:\\GPMM\\DATA"

u8 *zda_full_header = NULL;
F_HANDLE zda_file = 0;

int openZDA(const char *path)
{
	u8 header_12bytes[12];
	int real_headersize;
	char name[64];
    unsigned int tmp;

    if (smInit())
        return 1;

    sprintf(name,"%s\\%s",BASEDIR,path);
	smOpenFile(name,OPEN_R,&zda_file);
	if (zda_file == 1)
		return 1;

    smReadFile(zda_file, header_12bytes, 12, &tmp);
	real_headersize=gp_zda_headersize(header_12bytes);
	zda_full_header = (char*)malloc(real_headersize);
    smSeekFile(zda_file, FROM_BEGIN, 0, &tmp);
    smReadFile(zda_file, zda_full_header, real_headersize, &tmp);

	return 0;
}

void closeZDA()
{
    smCloseFile(zda_file);
	free(zda_full_header);
	zda_file = NULL;
	zda_full_header = NULL;
}

u8 *uncompressZDA(const char* filename,int* usize)
{
	u8 *compressed;
	u8 *uncompressed;
	int csize,offset;
    unsigned int tmp;

	csize  = gp_zda_csize (zda_full_header, filename);
	if (csize<=0)
		return NULL;
	offset = gp_zda_offset(zda_full_header, filename);

	*usize = gp_zda_usize (zda_full_header, filename);

	compressed   = (char*)malloc(csize);
	uncompressed = (char*)MALLOC(1,*usize);

    smSeekFile(zda_file, FROM_BEGIN, offset, &tmp);
    smReadFile(zda_file, compressed, csize, &tmp);

	if (gp_uncompressZDA(uncompressed,usize,compressed,csize)==1)
	{
		free(compressed);
		FREE(uncompressed);
		return NULL;
	}
	free(compressed);
	return uncompressed;
}

u8* loadZDAFile(const char *filename,const char *ext,int *size)
{
	int s,*sz;
	char name[16];
	sz = size==NULL?&s:size;
	sprintf(name,"%s.%s",filename,ext);
	return uncompressZDA((const char*)name,sz);
}
