#ifndef LEVELS_H_
#define LEVELS_H_

#define LEVEL_COUNT 13

#define BLOCK_ANCHOR 16
#define BLOCK_PUZZLE 32
#define BLOCK_PET    64
#define BLOCK_JOKER  128

const unsigned char tuto_level[13][13] =
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
        { 0, 0, 1, 3, BLOCK_ANCHOR | 8, 3, 3, 3, 3, 6, 1, 0, 0},
        { 0, 1, 3, BLOCK_ANCHOR | 8, 3, 8, 3, 3, 6, 3, BLOCK_PET | 6, 1, 0},
        { 0, 1, 3, 3, 3, 3, 3, 3, 3, 3, 6, 1, 0},
        { 0, 1, 3, 3, 6, 5, 6, 3, 3, 3, 3, 1, 0},
        { 0, 1, 3, 3, 5, 3, 5, 3, 3, 3, 3, 1, 0},
        { 0, 1, 3, 3, 2, BLOCK_PUZZLE | 5, 2, 3, 3, 3, 3, 1, 0},
        { 0, 1, 4, 3, 4, 3, BLOCK_PUZZLE | 5, 3, 3, BLOCK_JOKER | 8, 3, 1, 0},
        { 0, 1, 3, 4, 3, 3, 3, 3, BLOCK_JOKER | 5, 3, BLOCK_JOKER | 6, 1, 0},
        { 0, 0, 1, 3, 3, 3, 2, 3, 2, BLOCK_JOKER | 7, 1, 0, 0},
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    };

#define TUTO_STARTX 7
#define TUTO_STARTY 6

const char* tuto_texts[8] =
{
        "Move around",
        "Push blocks",
        "Puzzle to puzzle",
        "Unremovable blocks",
        "Anchor can not move",
        "Special pet blocks",
        "Joker",
        "That's it, Press START!"
};

#define TUTO_COUNT 42

const unsigned int tuto_moves[TUTO_COUNT*2] =
{
    BUTTON_RIGHT, 0,
    BUTTON_UP,    0,
    BUTTON_LEFT,  0,
    BUTTON_DOWN,  0,
    
    BUTTON_LEFT,  1,
    BUTTON_RIGHT, 1,
    BUTTON_UP,    1,
    BUTTON_LEFT,  1,
    
    BUTTON_RIGHT, 2,
    BUTTON_DOWN,  2,
    BUTTON_DOWN,  2,
    BUTTON_DOWN,  2,
    BUTTON_LEFT,  2,
    BUTTON_LEFT,  2,
    
    BUTTON_LEFT,  3,
    BUTTON_LEFT,  3,
    BUTTON_DOWN,  3,
    BUTTON_LEFT,  3,
    BUTTON_UP,    3,
    BUTTON_UP,    3,
    BUTTON_LEFT,  3,
    BUTTON_UP,    3,
    BUTTON_UP,    3,
    BUTTON_RIGHT, 3,
    BUTTON_UP,    3,
    
    BUTTON_UP,    4,
    BUTTON_RIGHT, 4,
    BUTTON_RIGHT, 4,
    BUTTON_RIGHT, 4,
    BUTTON_UP,    4,
    BUTTON_LEFT,  4,

    BUTTON_RIGHT, 5,
    BUTTON_RIGHT, 5,
    BUTTON_RIGHT, 5,
    BUTTON_RIGHT, 5,
    BUTTON_RIGHT, 5,
    BUTTON_DOWN,  5,

    BUTTON_LEFT,  6,
    BUTTON_DOWN,  6,
    BUTTON_DOWN,  6,
    BUTTON_DOWN,  6,
    BUTTON_DOWN,  7
};

// Block types
// 0 : none
// 1 : wall
// 2 : midwall
// 3 : ground
// 4 : uncolored block
// 5 to 8 : colored blocks

const unsigned char levels[LEVEL_COUNT][13][13] = {
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 5, 5, 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 5, 3, 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 6, 3, 6, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 5, 3, 3, 3, 6, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, 3, 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, 3, 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, BLOCK_ANCHOR | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 4, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, BLOCK_PUZZLE | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 5, BLOCK_PUZZLE | 5, 3, 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, BLOCK_PUZZLE | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 4, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, 3, 6, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, BLOCK_PUZZLE | 6, 2, 3, 1, 0, 0, 0},
        { 0, 0, 1, 1, 3, 4, 3, 3, BLOCK_PUZZLE | 5, 1, 1, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_PUZZLE | 5, 4, BLOCK_PUZZLE | 6, 6, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 7, 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, BLOCK_PET | 6, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 6, 2, 3, BLOCK_PET | 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 6, 3, 7, 5, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, BLOCK_PET | 6, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 5, 3, 5, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 6, BLOCK_ANCHOR | 6, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 5, 3, BLOCK_PET | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 6, 3, 3, BLOCK_PET | 6, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, BLOCK_ANCHOR | 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_PET | 7, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_ANCHOR | 7, 7, BLOCK_PET | 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, BLOCK_PET | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 7, 5, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 5, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, BLOCK_PET | 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 5, BLOCK_PUZZLE | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 1, 3, BLOCK_PUZZLE | 5, 5, 5, BLOCK_PUZZLE | 5, 3, 3, 1, 0, 0},
        { 0, 0, 0, 1, 3, 3, BLOCK_PUZZLE | 5, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, BLOCK_PUZZLE | 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, BLOCK_PUZZLE | 5, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, BLOCK_JOKER | 6, 3, 6, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, BLOCK_JOKER | 6, 3, BLOCK_JOKER | 6, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_JOKER | 6, BLOCK_JOKER | 5, BLOCK_JOKER | 5, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 6, 3, BLOCK_JOKER | 6, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 5, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 5, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_JOKER | 6, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 1, 3, BLOCK_JOKER | 6, 2, 3, BLOCK_JOKER | 5, 3, 3, 1, 0, 0},
        { 0, 0, 0, 1, 3, BLOCK_JOKER | 7, 3, BLOCK_JOKER | 8, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, BLOCK_JOKER | 7, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, BLOCK_JOKER | 8, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
        { 0, 0, 1, 3, BLOCK_PET | 8, 3, BLOCK_PET | 6, 3, BLOCK_PET | 5, 3, 1, 0, 0},
        { 0, 0, 1, BLOCK_PUZZLE | 7, 3, 8, 3, BLOCK_JOKER | 6, 3, BLOCK_ANCHOR | 7, 1, 0, 0},
        { 0, 1, 1, 3, BLOCK_PET | 7, 3, 4, 3, BLOCK_JOKER | 5, 3, 1, 1, 0},
        { 1, 0, 1, BLOCK_PUZZLE | 5, 3, 5, 3, BLOCK_JOKER | 8, 3, BLOCK_ANCHOR | 8, 1, 0, 1},
        { 0, 1, 1, 3, BLOCK_PUZZLE | 5, 3, BLOCK_PUZZLE | 6, 3, BLOCK_JOKER | 7, 3, 1, 1, 0},
        { 0, 0, 1, 8, 3, 6, 3, BLOCK_ANCHOR | 8, 3, BLOCK_ANCHOR | 6, 1, 0, 0},
        { 0, 0, 1, 3, BLOCK_PUZZLE | 5, 3, BLOCK_ANCHOR | 7, 3, BLOCK_ANCHOR | 5, 3, 1, 0, 0},
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0}
    },
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 1, 1, 5, 5, 1, 1, 1, 0, 0, 0},
        { 0, 0, 1, 5, 5, 3, 3, 3, 3, 3, 1, 0, 0},
        { 0, 0, 1, 5, 5, 5, 5, 3, 5, 3, 1, 0, 0},
        { 0, 0, 1, 5, 5, 5, 5, 5, 3, 5, 1, 1, 0},
        { 0, 1, 1, 5, 5, 5, 5, 3, 3, 3, 3, 1, 0},
        { 0, 1, 5, 5, 5, 5, 5, 5, 3, 5, 1, 1, 0},
        { 0, 1, 1, 5, 5, 5, 5, 3, 5, 3, 1, 0, 0},
        { 0, 0, 1, 5, 5, 5, 3, 3, 3, 3, 1, 0, 0},
        { 0, 0, 0, 1, 1, 1, 1, 1, 5, 1, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    }/*,
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 1, 3, 3, 3, 3, 3, 1, 0, 0, 0},
        { 0, 0, 0, 0, 1, 3, 3, 3, 1, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    }*/
};

const unsigned int startx[LEVEL_COUNT] = {7, 6, 8, 8, 6, 8, 8, 8, 9, 8, 9, 6, 10};
const unsigned int starty[LEVEL_COUNT] = {6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6};

#endif /*LEVELS_H_*/
