#include <stdlib.h>
#include <memory.h>

//#include <SDL.h>
#include <sys/stat.h>

#include "win32def.h"

#define SIZE (320*240)

/*
 * System
 */

void gp_Reset()
{
    exit(0);
}

u32 ticks = 0;
u32 gp_getRTC()
{
    return ticks++;//SDL_GetTicks()>>4;
}

int lastKey;
int lastKeyTyped;

u32 gp_getButton()
{
/*
    SDL_Event event;
    lastKeyTyped = 0;
    while (SDL_PollEvent(&event))
    {
        // check for messages
        switch (event.type)
        {
            // exit if the window is closed
            case SDL_QUIT:
                gp_Reset();
                break;

            // check for keypresses
            case SDL_KEYDOWN:
                {
                    if (event.key.keysym.sym == SDLK_UP)
                    {
                        if (lastKey&KEY_DOWN)
                            lastKey ^= KEY_DOWN;
                        lastKey |= KEY_UP;
                    }
                    else if (event.key.keysym.sym == SDLK_DOWN)
                    {
                        if (lastKey&KEY_UP)
                            lastKey ^= KEY_UP;
                        lastKey |= KEY_DOWN;
                    }
                    else if (event.key.keysym.sym == SDLK_RIGHT)
                    {
                        if (lastKey&KEY_LEFT)
                            lastKey ^= KEY_LEFT;
                        lastKey |= KEY_RIGHT;
                    }
                    else if (event.key.keysym.sym == SDLK_LEFT)
                    {
                        if (lastKey&KEY_RIGHT)
                            lastKey ^= KEY_RIGHT;
                        lastKey |= KEY_LEFT;
                    }
                    else if (event.key.keysym.sym == SDLK_SPACE)
                    {
                        lastKey |= KEY_BUTTON_A;
                    }
                    else if (event.key.keysym.sym == SDLK_b)
                    {
                        lastKey |= KEY_BUTTON_B;
                    }
                    else if (event.key.keysym.sym == SDLK_l)
                    {
                        lastKey |= KEY_BUTTON_L;
                    }
                    else if (event.key.keysym.sym == SDLK_r)
                    {
                        lastKey |= KEY_BUTTON_R;
                    }
                    else if (event.key.keysym.sym == SDLK_RETURN)
                    {
                        lastKey |= KEY_BUTTON_START;
                    }
                    else if (event.key.keysym.sym == SDLK_TAB)
                    {
                        lastKey |= KEY_BUTTON_SELECT;
                    }
                    // exit if ESCAPE is pressed
                    else if (event.key.keysym.sym == SDLK_ESCAPE)
                        gp_Reset();
                    break;
                }
            case SDL_KEYUP:
                {
                    if (event.key.keysym.sym == SDLK_UP)
                    {
                        if (lastKey&KEY_UP)
                            lastKey ^= KEY_UP;
                        lastKeyTyped = KEY_UP;
                    }
                    else if (event.key.keysym.sym == SDLK_DOWN)
                    {
                        if (lastKey&KEY_DOWN)
                            lastKey ^= KEY_DOWN;
                        lastKeyTyped = KEY_DOWN;
                    }
                    else if (event.key.keysym.sym == SDLK_RIGHT)
                    {
                        if (lastKey&KEY_RIGHT)
                            lastKey ^= KEY_RIGHT;
                        lastKeyTyped = KEY_RIGHT;
                    }
                    else if (event.key.keysym.sym == SDLK_LEFT)
                    {
                        if (lastKey&KEY_LEFT)
                            lastKey ^= KEY_LEFT;
                        lastKeyTyped = KEY_LEFT;
                    }
                    else if (event.key.keysym.sym == SDLK_SPACE)
                    {
                        if (lastKey&KEY_BUTTON_A)
                            lastKey ^= KEY_BUTTON_A;
                        lastKeyTyped = KEY_BUTTON_A;
                    }
                    else if (event.key.keysym.sym == SDLK_b)
                    {
                        if (lastKey&KEY_BUTTON_B)
                            lastKey ^= KEY_BUTTON_B;
                        lastKeyTyped = KEY_BUTTON_B;
                    }
                    else if (event.key.keysym.sym == SDLK_l)
                    {
                        if (lastKey&KEY_BUTTON_L)
                            lastKey ^= KEY_BUTTON_L;
                        lastKeyTyped = KEY_BUTTON_L;
                    }
                    else if (event.key.keysym.sym == SDLK_r)
                    {
                        if (lastKey&KEY_BUTTON_R)
                            lastKey ^= KEY_BUTTON_R;
                        lastKeyTyped = KEY_BUTTON_R;
                    }
                    else if (event.key.keysym.sym == SDLK_RETURN)
                    {
                        if (lastKey&KEY_BUTTON_START)
                            lastKey ^= KEY_BUTTON_START;
                        lastKeyTyped = KEY_BUTTON_START;
                    }
                    else if (event.key.keysym.sym == SDLK_TAB)
                    {
                        if (lastKey&KEY_BUTTON_SELECT)
                            lastKey ^= KEY_BUTTON_SELECT;
                        lastKeyTyped = KEY_BUTTON_SELECT;
                    }
                    break;
                }
        }
    }
*/
    return lastKey;
}

u32 getTickCount()
{
    return ticks++;//SDL_GetTicks();
}

/*
 * File
 */

int openZDA(char* zda)
{
    return 0;
}

void closeZDA(char* zda)
{
}

u8* loadZDAFile(const char* name,const char* ext,int* size)
{
    char buf[256];
    struct stat st;
    FILE *f;
    u8* data;
    sprintf(buf,"data/%s.%s",name,ext);
    stat(buf,&st);
    data = (u8*)malloc(st.st_size);
    f = fopen(buf,"rb");
    fread(data,st.st_size,1,f);
    fclose(f);
    if (size!=NULL)
        *size = st.st_size;
    return data;
}

/*
 * Gfx
 */

u32 nflip;
u32 framebuffers[1];
//SDL_Surface* screen;

void initGfx()
{
    nflip = 0;
    framebuffers[0] = (u32)malloc(SIZE<<1);
/*
    // initialize SDL video
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        exit(1);
    }

    // make sure SDL cleans up before exit
    atexit(SDL_Quit);

    // create a new window

    screen = SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE|SDL_DOUBLEBUF);
    if ( !screen )
    {
        printf("Unable to set 320x240 video: %s\n", SDL_GetError());
        exit(1);
    }
*/
}

void clearScreen()
{
    memset((void*)framebuffers[nflip],0,(SIZE<<1));
}

void flip(u32 sync)
{
/*
    int x,y,k;
    u16* buf=(u16*)framebuffers[nflip];
    u16 *pixD = (u16*)screen->pixels;
    int pitchD = screen->pitch>>1;
    // Fill screen with gp buffer (rotate)
    SDL_LockSurface(screen);
    for (x=0;x<320;++x)
    {
        k = 240;
        for (y=0;y<240;++y)
        {
            pixD[(y*pitchD)+x] = buf[--k+(240*x)];
*/
            /*
            u16 v = buf[(240-y)+(240*x)];
            pixD[(y*pitchD)+x] = (((v>>11)&0x1f)<<screen->format->Rshift) |
                                 (((v>>6)&0x1f)<<(screen->format->Gshift+1)) |
                                 (((v>>1)&0x1f)<<screen->format->Bshift);*/
/*
        }
    }
    SDL_UnlockSurface(screen);
    // SDL flip
    SDL_Flip(screen);
*/
}

void syncFPS(u32 startT, u32 curT, u32 fps)
{
/*
    if (curT<startT+fps)
        SDL_Delay(startT+fps-curT);
*/
}

void console_write(char *msg,u16 color)
{
    printf("MSG:%s\n",msg);
}

void console_write_no_lineup(char *msg,u16 color)
{
    printf("MSG:%s",msg);
}

u16* getCurrentBuffer()
{
    return (u16*)framebuffers[nflip];
}

void error(char *msg)
{
    printf("ERR:%s\n",msg);
}

void drawTextAt(char* text,int x,int y,u16 color)
{
}

/*
 * Music
 */

void gp_stopMusic()
{
}

void gp_startSound()
{
}

void gp_stopSound()
{
}

char* gp_getMusicTitle()
{
    return "";
}


char* gp_getMusicAuthor()
{
    return "";
}

void gp_playMusic()
{
}
