/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This product is based on the published OpenGL ES API, but is not an
 *  implementation which is certified or licensed by Silicon Graphics, Inc.
 *  under the OpenGL ES API.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Header: /cvsroot/klimt/klimt/klimt/include/egl_definitions.h,v 1.6 2004/07/29 08:54:09 drgoldie Exp $
 *
\**************************************************************************/

#ifndef __EGL_DEFINITIONS_HEADERFILE__
#define __EGL_DEFINITIONS_HEADERFILE__

#include "klMain.h"

/*
** Versioning and extensions
*/
#define EGL_VERSION_1_0                1

/*
** Boolean
*/
#ifndef EGL_FALSE
#define EGL_FALSE                      0
#endif

#ifndef EGL_TRUE
#define EGL_TRUE                       1
#endif

#define EGL_DRAW                       0x3059
#define EGL_READ                       0x305A

typedef void *	EGLDisplay;
typedef void *	EGLConfig;
typedef void *	EGLSurface;
typedef void *	EGLContext;

typedef int				EGLBoolean;
typedef unsigned int	EGLint;


#define EGL_DEFAULT_DISPLAY ((NativeDisplayType)0)
#define EGL_NO_CONTEXT ((EGLContext)0)
#define EGL_NO_DISPLAY ((EGLDisplay)0)
#define EGL_NO_SURFACE ((EGLSurface)0)

/*
** Errors
*/
#define EGL_SUCCESS                    0x3000
#define EGL_NOT_INITIALIZED            0x3001
#define EGL_BAD_ACCESS                 0x3002
#define EGL_BAD_ALLOC                  0x3003
#define EGL_BAD_ATTRIBUTE              0x3004
#define EGL_BAD_CONFIG                 0x3005
#define EGL_BAD_CONTEXT                0x3006
#define EGL_BAD_CURRENT_SURFACE        0x3007
#define EGL_BAD_DISPLAY                0x3008
#define EGL_BAD_MATCH                  0x3009
#define EGL_BAD_NATIVE_PIXMAP          0x300A
#define EGL_BAD_NATIVE_WINDOW          0x300B
#define EGL_BAD_PARAMETER              0x300C
#define EGL_BAD_SURFACE                0x300D
/* 0x300E - 0x301F reserved for additional errors. */


#ifdef _IS_WINDOWS_

  #include <windows.h>
  typedef HDC		NativeDisplayType;
  typedef HWND		NativeWindowType;
  typedef HBITMAP	NativePixmapType;

#endif //_IS_WINDOWS_

#ifdef _IS_LINUX_

  #ifndef NULL
  	#define NULL 0L
  #endif

  #ifdef _IS_QTEMBEDDED_
    	#include <qwidget.h>
	typedef void*		NativeDisplayType;
	typedef QWidget*	NativeWindowType;
	typedef void*		NativePixmapType;	
  #endif //_IS_QTEMBEDDED_

  #ifdef _IS_SDL_
    typedef void*		NativeDisplayType;
    typedef void*		NativeWindowType;
    typedef void*		NativePixmapType;
  #endif //_IS_SDL_
  
#endif //_IS_LINUX_

#ifdef _IS_SYMBIAN32_
	class RWsSession;
	class RWindow;

	typedef RWsSession*	NativeDisplayType;
	typedef RWindow*	NativeWindowType;

#endif // _IS_SYMBIAN32_

#ifdef _IS_GP32_
	typedef void*         NativeDisplayType;
	typedef void*         NativeWindowType;
	typedef void*         NativePixmapType;
#endif //_IS_GP32_
	
#endif // __EGL_DEFINITIONS_HEADERFILE__
