/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This product is based on the published OpenGL ES API, but is not an
 *  implementation which is certified or licensed by Silicon Graphics, Inc.
 *  under the OpenGL ES API.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Header: /cvsroot/klimt/klimt/klimt/include/klFixed.h,v 1.1 2004/07/30 12:42:54 drgoldie Exp $
 *
\**************************************************************************/


#ifndef __KLFIXED_HEADERFILE__
#define __KLFIXED_HEADERFILE__


#include "klMain.h"
#include "../src/Base/klFloat_fixed.h"


#if defined(_USE_FIXED_GPP_)			// fixed point with usage of the Intel GPP

  #include "../src/Base/klFixedBase_gpp.h"
  typedef klFloat_fixed<klFixedBase_gpp> klFixed;

#elif defined(_USE_FIXED_ARM_)			// fixed point base for ARM processors

  #include "../src/Base/klFixedBase_arm.h"
  typedef klFloat_fixed<klFixedBase_arm> klFixed;

#else									// generic fixed point - should run almost everywhere (needs __int64)

  #include "../src/Base/klFixedBase_generic.h"
  typedef klFloat_fixed<klFixedBase_generic> klFixed;

#endif //_USE_FIXED_GPP_


#endif //__KLFIXED_HEADERFILE__
