/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This product is based on the published OpenGL ES API, but is not an
 *  implementation which is certified or licensed by Silicon Graphics, Inc.
 *  under the OpenGL ES API.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Header: /cvsroot/klimt/klimt/klimt/src/Base/klFixedBaseInterceptor.h,v 1.1 2004/07/11 20:00:17 wasserer Exp $
 *
\**************************************************************************/

extern int mulCount;
extern int divCount;
extern int sqrtCount;
extern int invSqrtCount;
extern int trigCount;

template <class MATHBASE> 
class klFixedBaseInterceptor
{
public:
	enum {
		PBITS = MATHBASE::PBITS
	};

	static float floatFromFixed(int nFixed)
	{
		return MATHBASE::floatFromFixed(nFixed);
	}

	static double doubleFromFixed(int nFixed)
	{
		return MATHBASE::doubleFromFixed(nFixed);
	}

	static int fixedFromInt(int nV)
	{
		return MATHBASE::fixedFromInt(nV);
	}

	static int fixedFromFloat(float nV)
	{
		return MATHBASE::fixedFromFloat(nV);
	}

	static int fixedFromDouble(double nV)
	{
		return MATHBASE::fixedFromDouble(nV);
	}

	static int inverse(int nFixed)
	{
		return MATHBASE::inverse(nFixed);
	}

	static int multiply(int nLeftFixed, int nRightFixed)
	{
		mulCount++;
		return MATHBASE::multiply(nLeftFixed, nRightFixed);
	}

	static int divide(int nLeftFixed, int nRightFixed)
	{
		divCount++;
		return MATHBASE::divide(nLeftFixed, nRightFixed);
	}

	static int cos(int nFixed)
	{
		trigCount++;
		return MATHBASE::cos(nFixed);
	}

	static int sin(int nFixed)
	{
		trigCount++;
		return MATHBASE::sin(nFixed);
	}

	static int fabs(int nFixed)
	{
		return MATHBASE::fabs(nFixed);
	}

	static int sqrt(int nFixed)
	{
		sqrtCount++;
		return MATHBASE::sqrt(nFixed);
	}

	static int inverseSqrt(int nFixed)
	{
		invSqrtCount++;
		return MATHBASE::inverseSqrt(nFixed);
	}

	static int ceil(int nFixed)
	{
		return MATHBASE::ceil(nFixed);
	}
};
