/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Id: klEGLDisplayEpoc.cpp,v 1.1 2004/08/01 10:29:33 drgoldie Exp $
 *
\**************************************************************************/

#include "klMain.h"
#include "../klEGLNative.h"
#include "egl_definitions.h"

#ifdef __EXE__

bool klEGLDisplayEpoc::initDefaultWsSession()
{
	wsSession = new RWsSession();
	ownsWsSession = true;
	if( wsSession->Connect()!=KErrNone )
		return false;

	return true;
}
	
#else //__EXE__

#include <coemain.h>
bool klEGLDisplayEpoc::initDefaultWsSession()
{
	CCoeEnv* pEnv = CCoeEnv::Static();
	wsSession = &(pEnv->WsSession());

	return true;
}

#endif //!__EXE__

klEGLDisplayEpoc::klEGLDisplayEpoc(NativeDisplayType nDisp, EGLint& error)
{
	ownsWsSession = false;

	wsSession = nDisp;
	if( wsSession==EGL_DEFAULT_DISPLAY )
	{
		if( !initDefaultWsSession() )
		{
			error = EGL_NOT_INITIALIZED;
			return;
		}
	}

	wsScreen = new CWsScreenDevice(*wsSession);

	if( wsScreen->Construct() != KErrNone ||
		wsScreen->CreateContext(windowGc) != KErrNone ) 
	{
		error = EGL_NOT_INITIALIZED;
		return;
	}

	error = EGL_SUCCESS;
}

klEGLDisplayEpoc::~klEGLDisplayEpoc()
{
	delete windowGc;
	delete wsScreen;
	if( ownsWsSession )
		delete wsSession;
}