/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Id: klEGLDisplayEpoc.h,v 1.1 2004/08/01 10:29:33 drgoldie Exp $
 *
\**************************************************************************/


#ifndef __KLEGLDISPLAY_EPOC_HEADERFILE__
#define __KLEGLDISPLAY_EPOC_HEADERFILE__

#include "egl_definitions.h"
#include <w32std.h>

/**
 *  Implementation of EGLSurface for Symbian. At the moment
 *  this is an empty skeleton without functionality provided
 *  to enable the compilation of the Klimt lib for Symbian.
 */
class klEGLDisplayEpoc
{
public:
	klEGLDisplayEpoc(NativeDisplayType nDisp, EGLint& error);
	~klEGLDisplayEpoc();

	RWsSession*			getWsSession() { return wsSession; }
	CWsScreenDevice*	getWsScreen()  { return wsScreen;  }
	CWindowGc*			getWindowGc()  { return windowGc;  }
	
private:
	bool				initDefaultWsSession();

	RWsSession*			wsSession;
	CWsScreenDevice*	wsScreen;
	CWindowGc*			windowGc;
	bool				ownsWsSession;
};




#endif //__KLEGLDISPLAY_EPOC_HEADERFILE__
