/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This product is based on the published OpenGL ES API, but is not an
 *  implementation which is certified or licensed by Silicon Graphics, Inc.
 *  under the OpenGL ES API.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Header: /cvsroot/klimt/klimt/klimt/src/RasterizerSW565/klRSW565_Scanline_ZBuffer.h,v 1.8 2004/06/15 10:17:33 wasserer Exp $
 *
\**************************************************************************/


//
// class klRSW565 {
//


////////////////////////////
//
//    Without Z-Writing
//

int	drawScanLine_ZBuffer_Always_NoWrite(const klFloat& /*nLeftZ*/, const klFloat& /*nRightZ*/, const klFloat& /*nPreStep*/,
										int nLen, const klFloat& /*nLenInv*/, int /*nOffset*/, int /*nOffsetLR*/)
{
	scanlineRunLengths[0] = (unsigned short)nLen;
	scanlineRunLengths[1] = 0;
	return 1;
}


int	drawScanLine_ZBuffer_Never_NoWrite(const klFloat& /*nLeftZ*/, const klFloat& /*nRightZ*/, const klFloat& /*nPreStep*/,
									   int /*nLen*/, const klFloat& /*nLenInv*/, int /*nOffset*/, int /*nOffsetLR*/)
{
	scanlineRunLengths[0] = scanlineRunLengths[1] = 0;
	return 0;
}


int drawScanLine_ZBuffer_Less_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									  int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src = zBuffer+nOffset,
							//*srcLR = zBufferLR+nOffsetLR,
							*src0 = src;

#define TEST_OP <
#define TEST_OP_NEG >=

//
// work in progress for the upcomming additional low-res zbuffer
//

/*
	// first we check the whole span for being the same as the first pixel
	// if this check passes, we can skip the detailed test.
	// if it fails the normal test is invoked by jumping to LabelStdTest.

	if(iZ.isStepPositive())			// positive dz means, that iZ is minimum value, iZR is maximum value
	{
		curZ = iZ.getZ();
		if(curZ TEST_OP *src)				// first pixel is visible, this means we test each cell's right-most value for visibility
		{
			int restInFirstCell = min(Z_LOWRES_FACT - (x&Z_LOWRES_MASK), len);
			iZR = iZ;
			iZR.step(restInFirstCell-1);		// step to the right-most pixel of the first cell...
			srcLR += (restInFirstCell-1)<<1;	// same with buffer pointer

			// test for first cell
			//
			curZ = iZR.getZ();
			if(curZ TEST_OP_NEG *srcLR)
				goto LabelStdTest;

			len -= restInFirstCell;

			// test all complete cells
			//
			while(len>Z_LOWRES_FACT)
			{
				iZR.step8();
				srcLR += Z_LOWRES_FACT_BYTWO;

				curZ = iZR.getZ();
				if(curZ TEST_OP_NEG *srcLR)
					goto LabelStdTest;

				len-=Z_LOWRES_FACT;
			}

			// test final cell
			//
			if(len>0)
			{
				iZR.step(len);
				srcLR += (len<<1);

				curZ = iZR.getZ();
				if(curZ TEST_OP_NEG *srcLR)
					goto LabelStdTest;
			}

			scanlineRunLengths[0] = (unsigned short)nLen;
			return 1;
		}
		else						// first pixel is invisible, this means we test each cell's left-most value for invisibility
		{
			int restInFirstCell = min(Z_LOWRES_FACT - (x&Z_LOWRES_MASK), len);

			// test for first cell
			//
			curZ = iZ.getZ();
			if(curZ TEST_OP srcLR[1])
				goto LabelStdTest;

			len -= restInFirstCell;
			iZ.step(restInFirstCell);
			srcLR += restInFirstCell<<1;

			// test all complete cells
			//
			while(len>Z_LOWRES_FACT)
			{
				curZ = iZ.getZ();
				if(curZ TEST_OP srcLR[1])
					goto LabelStdTest;

				iZ.step8();
				srcLR += Z_LOWRES_FACT_BYTWO;
				len-=8;
			}

			// test final cell
			//
			if(len>0)
			{
				curZ = iZ.getZ();
				if(curZ TEST_OP srcLR[1])
					goto LabelStdTest;
			}

			scanlineRunLengths[0] = 0;
			return 1;
		}
	}
	else							// negative dz means, that iZ is maximum value, iZR is minimum value
	{
		curZ = iZ.getZ();
		if(curZ TEST_OP *src)				// first pixel is visible, this means we test each cell's left-most value for visibility
		{
			int restInFirstCell = min(Z_LOWRES_FACT - (x&Z_LOWRES_MASK), len);

			// test for first cell
			//
			curZ = iZ.getZ();
			if(curZ TEST_OP_NEG *srcLR)
				goto LabelStdTest;

			len -= restInFirstCell;
			iZ.step(restInFirstCell);
			srcLR += restInFirstCell<<1;

			// test all complete cells
			//
			while(len>Z_LOWRES_FACT)
			{
				curZ = iZ.getZ();
				if(curZ TEST_OP_NEG *srcLR)
					goto LabelStdTest;

				iZ.step8();
				srcLR += Z_LOWRES_FACT_BYTWO;
				len-=8;
			}

			// test final cell
			//
			if(len>0)
			{
				curZ = iZ.getZ();
				if(curZ TEST_OP_NEG *srcLR)
					goto LabelStdTest;
			}

			scanlineRunLengths[0] = (unsigned short)nLen;
			return 1;
		}
		else						// first pixel is invisible, this means we test each cell's right-most value for invisibility
		{
			int restInFirstCell = min(Z_LOWRES_FACT - (x&Z_LOWRES_MASK), len);
			iZR = iZ;
			iZR.step(restInFirstCell-1);		// step to the right-most pixel of the first cell...
			srcLR += (restInFirstCell-1)<<1;	// same with buffer pointer

			// test for first cell
			//
			curZ = iZR.getZ();
			if(curZ TEST_OP srcLR[1])
				goto LabelStdTest;

			len -= restInFirstCell;

			// test all complete cells
			//
			while(len>Z_LOWRES_FACT)
			{
				iZR.step8();
				srcLR += Z_LOWRES_FACT_BYTWO;

				curZ = iZR.getZ();
				if(curZ TEST_OP srcLR[1])
					goto LabelStdTest;

				len-=Z_LOWRES_FACT;
			}

			// test final cell
			//
			if(len>0)
			{
				iZR.step(len);
				srcLR += (len<<1);

				curZ = iZR.getZ();
				if(curZ TEST_OP srcLR[1])
					goto LabelStdTest;
			}

			scanlineRunLengths[0] = 0;
			return 1;
		}
	}



LabelStdTest:
*/

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ TEST_OP *src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ TEST_OP_NEG *src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_LessEqual_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
										   int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Equal_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									   int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ==*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ!=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_GreaterEqual_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
											  int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Greater_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
										 int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Notequal_NoWrite(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
										  int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ!=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ==*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}



////////////////////////////
//
//      With Z-Writing
//

int drawScanLine_ZBuffer_Always_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									  int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	DEPTHTYPE				*src=zBuffer+nOffset;

	scanlineRunLengths[0] = (unsigned short)nLen;

	while(nLen--)
	{
		*(src++) = iZ.getZ();
		iZ.step();
	}

	return 1;
}


int	drawScanLine_ZBuffer_Never_Write(const klFloat& /*nLeftZ*/, const klFloat& /*nRightZ*/, const klFloat& /*nPreStep*/,
									 int /*nLen*/, const klFloat& /*nLenInv*/, int /*nOffset*/, int /*nOffsetLR*/)
{
	return 0;
}


int drawScanLine_ZBuffer_Less_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_LessEqual_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
										 int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<=*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Equal_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									 int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ==*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ!=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_GreaterEqual_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
										    int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>=*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Greater_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									   int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ>*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ<=*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


int drawScanLine_ZBuffer_Notequal_Write(const klFloat& nLeftZ, const klFloat& nRightZ, const klFloat& nPreStep,
									    int nLen, const klFloat& nLenInv, int nOffset, int /*nOffsetLR*/)
{
	InterpolatorZ_Linear	iZ(nLeftZ, nRightZ, nPreStep, nLenInv);
	klFloat					curZ;
	int						rlIdx=0;
	DEPTHTYPE				*src=zBuffer+nOffset,
							*src0 = src;

	while(nLen>0)
	{
		// we start with visible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ!=*src)
			{
				*(src++) = curZ;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				src++;
				break;
			}
		}

		if(nLen<=0)
			break;

		// now count invisible pixels
		while(nLen--)
		{
			curZ = iZ.getZ();
			iZ.step();
			if(curZ==*src)
			{
				src++;
			}
			else
			{
				scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
				src0 = src;
				*(src++) = curZ;
				break;
			}
		}
	}

	scanlineRunLengths[rlIdx++] = (unsigned short)(src-src0);
	return rlIdx;
}


DEPTHFUNC drawScanLine_GetDepthFunc(RASTER_MODE_ZWRITE nZWrite, RASTER_MODE_ZTEST nZTest)
{
	if(nZWrite==RASTER_ZWRITE_OFF)			// no z-write
	{
		switch(nZTest)
		{
		case RASTER_ZTEST_ALWAYS:
			return &klRSW565::drawScanLine_ZBuffer_Always_NoWrite;

		case RASTER_ZTEST_NEVER:
			return &klRSW565::drawScanLine_ZBuffer_Never_NoWrite;

		case RASTER_ZTEST_LESS:
			return &klRSW565::drawScanLine_ZBuffer_Less_NoWrite;

		case RASTER_ZTEST_LEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_LessEqual_NoWrite;

		case RASTER_ZTEST_EQUAL:
			return &klRSW565::drawScanLine_ZBuffer_Equal_NoWrite;

		case RASTER_ZTEST_GEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_GreaterEqual_NoWrite;

		case RASTER_ZTEST_GREATER:
			return &klRSW565::drawScanLine_ZBuffer_Greater_NoWrite;

		case RASTER_ZTEST_NOTEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_Notequal_NoWrite;
		}
	}
	else									// z-write
	{
		switch(nZTest)
		{
		case RASTER_ZTEST_ALWAYS:
			return &klRSW565::drawScanLine_ZBuffer_Always_Write;

		case RASTER_ZTEST_NEVER:
			return &klRSW565::drawScanLine_ZBuffer_Never_Write;

		case RASTER_ZTEST_LESS:
			return &klRSW565::drawScanLine_ZBuffer_Less_Write;

		case RASTER_ZTEST_LEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_LessEqual_Write;

		case RASTER_ZTEST_EQUAL:
			return &klRSW565::drawScanLine_ZBuffer_Equal_Write;

		case RASTER_ZTEST_GEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_GreaterEqual_Write;

		case RASTER_ZTEST_GREATER:
			return &klRSW565::drawScanLine_ZBuffer_Greater_Write;

		case RASTER_ZTEST_NOTEQUAL:
			return &klRSW565::drawScanLine_ZBuffer_Notequal_Write;
		}
	}


	// should never come here...
	//
	return &klRSW565::drawScanLine_ZBuffer_Never_NoWrite;
}

//
// } class klRSW565
//
