/**************************************************************************\
 *
 *  This file is part of the Klimt library.
 *  Copyright (C) 2003 by IMS, Vienna University of Technology.
 *  All rights reserved.
 *
 *  This product is based on the published OpenGL ES API, but is not an
 *  implementation which is certified or licensed by Silicon Graphics, Inc.
 *  under the OpenGL ES API.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *  For the full GPL license see
 *  <URL:http://www.gnu.org/copyleft/gpl.html>
 *
 *  For using Klimt with software that can not be combined with the
 *  GNU GPL, and for taking advantage of the additional benefits of
 *  our support services, please contact IMS about acquiring a
 *  Klimt Professional Edition License.
 *
 *  Contact: <mailto:klimt@studierstube.org>
 *  See <URL:http://www.studierstube.org/klimt>
 *  for more information.
 *
 *  Vienna University of Technology
 *  Institute for Software Technology and Interactive Systems
 *  Interactive Media Systems Group
 *  Favoritenstrasse 9-11/188/2
 *  A-1040 Vienna, Austria
 *  <URL:http://www.ims.tuwien.ac.at>.
 *
 **************************************************************************
 *
 * $Header: /cvsroot/klimt/klimt/klimt/src/klContext_PrimitiveAssembler.h,v 1.17 2004/05/03 08:14:49 drgoldie Exp $
 *
\**************************************************************************/



/**
class klContext
{
*/


//
// This file contains all methods that create
// primitives from the current state settings
// and pass them on to the rasterizer
//
// Most methods are defined in the 
// corresponding .cpp file. This is 
// due to problems with the GCC compilers for
// Symbian, which have bad heuristics to determine
// if a function should be inlined.
// 

bool
checkAllCulledAway(GLenum nPrimType)
{
	return cullingEnabled && cullMode==GL_FRONT_AND_BACK &&
		   nPrimType!=GL_POINTS && nPrimType!=GL_LINES && nPrimType!=GL_LINE_STRIP && nPrimType!=GL_LINE_LOOP;
}


void checkModelProjMatrix();
void applyArrayElement(int nIndex);
void renderArray(GLenum nPrimType, GLsizei nCount, GLenum nIndexType, const GLvoid* nIndices);
void renderBeginEndPrimitive();
void renderPrimitive(GLenum nPrimType, klVertex* nVertices, GLsizei nPrimLen);
void clipCoordsToWindowCoords(klVertex* nVertices, GLsizei nNum);
bool checkCulling(const klVertex* nVertices, int nNum);
void configureRasterizer();
void calculateVertexLighting(klVertex& nVertex, const klVec3& nVertexNormal, bool nFrontSide);

/**
}  // class klContext
*/
