//
// This code was created by Jeff Molofee '99 (ported to Linux/GLUT by Richard Campbell '99)
//
// If you've found this code useful, please let me know.
//
// Visit me at www.demonews.com/hosted/nehe 
// (email Richard Campbell at ulmont@bellsouth.net)
//
// ################################################
// 
// And it was ported to Klimt for GP32 by maulo/Necrostudios
//
// I really found the code useful ;-)
//

#include "gp32.h"
#include "fileio.h"

#include "gl/gl.h"	// Header File For The OpenGL32 Library
#include "gl/glu.h"	// Header File For The GLu32 Library
#include <stdlib.h>     // Header file for malloc/free.

// Pointers to the frameuffers
u16 *screen;
u16 *screen2;

// For the FPS count
long r;
int fps;
char text_fps[3];

// Color correction flag
int color_correction = 1;

// The modfile in C format
extern unsigned char modfile1[];

/* floats for x rotation, y rotation, z rotation */
float xrot, yrot, zrot;

/* storage for one texture  */
int texture[1];

/* Image type - contains height, width, and data */
struct Image {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
};
typedef struct Image Image;


// Again, this dirty function
void torgb555(u16 s[]) {
	int i;
	unsigned short l,r;

	for ( i = 0 ; i < 320*240 ; i++) {
		l = s[i] & 0xFFC0;  // Left
		r = s[i] & 0x001F;  // Right losing MSB

		r = r << 1;

		s[i] = l | r;
	}
}

// Function to toggle the color correction flag
void toggleColorCorrection() {

	if (color_correction == 0) color_correction = 1;
	else color_correction = 0;
}



// quick and dirty bitmap loader...for 24 bit bitmaps with 1 plane only.  
// See http://www.dcs.ed.ac.uk/~mxr/gfx/2d/BMP.txt for more info.
// NOTE OF PORTER: In the GP32, I don't know the f**k why but the
// texture loads backwards :-(
int ImageLoad(char *filename, Image *image) {
    GPFILE *file;
    unsigned long size;                 // size of the image in bytes.
    unsigned long i;                    // standard counter.
    unsigned short int planes;          // number of planes in image (must be 1) 
    unsigned short int bpp;             // number of bits per pixel (must be 24)
    char temp;                          // temporary color storage for bgr-rgb conversion.

    // make sure the file is there.
    if ((file = smc_fopen(filename, "rb"))==NULL)
    {
	gp_drawString(10,110,8,"NO FILE",0xF800,screen);
	while(1)	
	    if ( gp_getButton()&BUTTON_A ) gp_Reset();
	return 0;
    }
    
    // seek through the bmp header, up to the width/height:
    fseek(file, 18, SEEK_CUR);

    // read the width
    if ((i = smc_fread(&image->sizeX, 4, 1, file)) != 1) {
	gp_drawString(10,110,11,"ERROR WIDTH",0xF800,screen);
    }
    
    // read the height 
    if ((i = fread(&image->sizeY, 4, 1, file)) != 1) {
	gp_drawString(10,110,11,"ERROR HEIGHT",0xF800,screen);
    }
    
    // calculate the size (assuming 24 bits or 3 bytes per pixel).
    size = image->sizeX * image->sizeY * 3;

    // read the planes
    if ((fread(&planes, 2, 1, file)) != 1) {
	gp_drawString(10,110,11,"ERROR PLANES",0xF800,screen);
    }
    if (planes != 1) {
	gp_drawString(10,110,11,"ERROR PLANES2",0xF800,screen);
    }

    // read the bpp
    if ((i = fread(&bpp, 2, 1, file)) != 1) {
	gp_drawString(10,110,10,"ERROR BPP",0xF800,screen);
    }
    if (bpp != 24) {
    }
	
    // seek past the rest of the bitmap header.
    fseek(file, 24, SEEK_CUR);

    // read the data. 
    image->data = (char *) malloc(size);
    if (image->data == NULL) {
	gp_drawString(10,110,10,"ERROR MEM",0xF800,screen);
    }

    if ((i = fread(image->data, size, 1, file)) != 1) {
	gp_drawString(10,110,11,"ERROR IMAGE",0xF800,screen);
    }

    for (i=0;i<size;i+=3) { // reverse all of the colors. (bgr -> rgb)
	temp = image->data[i];
	image->data[i] = image->data[i+2];
	image->data[i+2] = temp;
    }
    
    // we're done.
    smc_fclose(file);
    return 1;
}
    
// Load Bitmaps And Convert To Textures
void LoadGLTextures() {	
    // Load Texture
    Image *image1;
    
    // allocate space for texture
    image1 = (Image *) malloc(sizeof(Image));
    if (image1 == NULL) {
	gp_drawString(10,120,10,"NO MEMORY",0xF800,screen);
    }

    if (!ImageLoad("dev0:\\gpmm\\nehe.bmp", image1)) {
	    gp_drawString(10,130,15,"FILE NOT FOUND",0xF800,screen);
	    while(1)	
	    	if ( gp_getButton()&BUTTON_A ) gp_Reset();
    }        

    // Create Texture	
    glGenTextures(1, (GLuint *)&texture[0]);
    glBindTexture(GL_TEXTURE_2D, texture[0]);   // 2d texture (x and y size)

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR); // scale linearly when image bigger than texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR); // scale linearly when image smalled than texture

    // 2d texture, level of detail 0 (normal), 3 components (red, green, blue), x size from image, y size from image, 
    // border 0 (normal), rgb color data, unsigned byte data, and finally the data itself.
    glTexImage2D(GL_TEXTURE_2D, 0, 3, image1->sizeX, image1->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, image1->data);

    // Tweaking
    klCreateMipMaps();
};

/* A general OpenGL initialization function.  Sets all of the initial parameters. */
void InitGL(int Width, int Height)	        // We call this right after our OpenGL window is created.
{
    LoadGLTextures();				// Load The Texture(s) 
    glEnable(GL_TEXTURE_2D);			// Enable Texture Mapping
    glClearColor(0.0f, 0.0f, 1.0f, 0.0f);	// Clear The Background Color To Blue 
    glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer
    glDepthFunc(GL_LESS);			// The Type Of Depth Test To Do
    glEnable(GL_DEPTH_TEST);			// Enables Depth Testing
    glShadeModel(GL_FLAT);			// Enables Smooth Color Shading
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();				// Reset The Projection Matrix
    
    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);	// Calculate The Aspect Ratio Of The Window
    
    glMatrixMode(GL_MODELVIEW);

    glCullFace(GL_FRONT);
}

/* The function called when our window is resized (which shouldn't happen, because we're fullscreen) */
void ReSizeGLScene(int Width, int Height)
{
    if (Height==0)				// Prevent A Divide By Zero If The Window Is Too Small
	Height=1;

    glViewport(0, 0, Width, Height);		// Reset The Current Viewport And Perspective Transformation

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);
    glMatrixMode(GL_MODELVIEW);
}

/* The main drawing function. */
void DrawGLScene()
{
  int i;
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
  
  for ( i = 0 ; i < 4 ; i++ ) {
	
    glLoadIdentity();				// Reset The View

    //glTranslatef(0.0f,0.0f,-5.0f);              // move 5 units into the screen.
    if ( i == 0 ) glTranslatef(3.0f,2.5f,-15.0f);           
    if ( i == 1 ) glTranslatef(-3.0f,2.5f,-15.0f);       
    if ( i == 2 ) glTranslatef(3.0f,-2.5f,-15.0f);       
    if ( i == 3 ) glTranslatef(-3.0f,-2.5f,-15.0f);     
    
    glRotatef(xrot,1.0f,0.0f,0.0f);		// Rotate On The X Axis
    glRotatef(yrot,0.0f,1.0f,0.0f);		// Rotate On The Y Axis
    glRotatef(zrot,0.0f,0.0f,1.0f);		// Rotate On The Z Axis

    glBindTexture(GL_TEXTURE_2D, texture[0]);   // choose the texture to use.

    // Tweaking
    klCreateMipMaps();
    
    glBegin(GL_QUADS);		                // begin drawing a cube
    
    // Front Face (note that the texture's corners have to match the quad's corners)
    glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
    
    // Back Face
    glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
	
    // Top Face
    glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
    
    // Bottom Face       
    glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
    
    // Right face
    glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
    glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
    
    // Left Face
    glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
    glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
    glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
    glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
    
    glEnd();                                    // done with the polygon.
  
  }
  
    xrot+=2.0f;		                // X Axis Rotation	
    yrot+=2.0f;		                // Y Axis Rotation
    zrot+=2.0f;		                // Z Axis Rotation

}


int main(int argc, char **argv) 
{  
	
	// Our infamous counter
	int contador = 0;

	// The twin framebuffers
	screen = (u16*) FRAMEBUFFER1;
	screen2 = (u16*) FRAMEBUFFER2;

	// This was just copy-pasted from Mr.Mirkos examples
	// using modplaying
	gp_setMMU ( screen, screen+(320*240*2)-1, 0xFF2 );
	gp_setMMU ( screen2, screen2+(320*240*2)-1, 0xFF2 );

	// This is tough, we need all the power we can get
	gp_setCpuspeed(133);
	gp_initFramebuffer(screen2,16,85);
	gp_initFramebuffer(screen,16,85);

	// "How do you do Mrs.Klimt?" ;-)
	klCreateDefaultContext();
	klSetBufferSize(240, 320);
	klSetColorBuffer(screen2);

	// Tweaking
	//klTweak(KL_TEXTUREMATRIX, GL_FALSE);  // static_cast
	klTweak(KL_TEXTUREMATRIX, 0);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
	//klTweak(KL_ENABLE_NORMALIZATION, GL_FALSE);
	klTweak(KL_ENABLE_NORMALIZATION, 0);
	
	// Setting up our initial framebuffer
	gp_setFramebuffer(screen,1);

	// We set up our Real Time Clock
	gp_initRTC();

	/* Initialize our window. */
	InitGL(240, 320);

	// Let the music start
	gp_startSoundmixer(0);
	gp_startModfile(modfile1);

	// For the FPS count
	r = 0;
        fps = 0;
	
	/* Start Event Processing Engine */
	// NOTE FROM PORTER: Also known as "Main loop" is
	// some places :-)
	// The main loop is the same as if didn't have any sound.
	// Mr.Mirko's library handles that quite well
	while(1){
		DrawGLScene();

		// The FPS stuff
		r = gp_getRTC();

		// If less than a second has passed, increase the number of frames
		if ( r < 64 ) {
			fps++;
		} else {
			// We reset the count
			gp_clearRTC();
			sprintf(text_fps, "%d", fps);
			fps = 0;
		}
		
		if ( contador == 0 ) {
			contador = 1;
			if (color_correction == 1) {
				torgb555(screen2);
				gp_drawString(300,20,2,"CC",0xFFC0,screen2);
			}
			gp_drawString(300,10,3,text_fps,0xFFC0,screen2);
			gp_setFramebuffer(screen2,1);
			klSetColorBuffer(screen);
		} else {
			contador = 0;
			if (color_correction == 1) {
				torgb555(screen);
				gp_drawString(300,20,2,"CC",0xFFC0,screen);
			}
			gp_drawString(300,10,3,text_fps,0xFFC0,screen);
			gp_setFramebuffer(screen,1);
			klSetColorBuffer(screen2);
		}

		if ( gp_getButton()&BUTTON_A ) gp_Reset();
		if ( gp_getButton()&BUTTON_B ) toggleColorCorrection();
	}

	return 0;

}

