
#include "gp32.h"

#include "gl/gl.h"
#include "gl/glu.h"

//#include <GL/glut.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define PI_ 3.14159265358979323846

// Pointers to the frameuffers
u16 *screen;
u16 *screen2;

// For the FPS count
long r;
int fps;
char text_fps[3];

// Color correction flag
int color_correction = 0;

GLuint theTorus;

// Our "Keyboard"
enum { UP = 0, DOWN, LEFT, RIGHT, L, R, A, B, SELECT, START};

// Again, this dirty function
void torgb555(u16 s[]) {
        int i;
        unsigned short l,r;

        for ( i = 0 ; i < 320*240 ; i++) {
                l = s[i] & 0xFFC0;  // Left
                r = s[i] & 0x001F;  // Right losing MSB

                r = r << 1;

                s[i] = l | r;
        }
}

// Function to toggle the color correction flag
void toggleColorCorrection() {

        if (color_correction == 0) color_correction = 1;
        else color_correction = 0;
}



/* Draw a torus */
static void torus(int numc, int numt)
{
   int i, j, k;
   double s, t, x, y, z, twopi;

   twopi = 2 * PI_;
   for (i = 0; i < numc; i++) {
      glBegin(GL_QUAD_STRIP);
      for (j = 0; j <= numt; j++) {
         for (k = 1; k >= 0; k--) {
            s = (i + k) % numc + 0.5;
            t = j % numt;

            x = (1+.1*cos(s*twopi/numc))*cos(t*twopi/numt);
            y = (1+.1*cos(s*twopi/numc))*sin(t*twopi/numt);
            z = .1 * sin(s * twopi / numc);
            glVertex3d(x, y, z);
         }
      }
      glEnd();
   }
}

/* Create display list with Torus and initialize state */
static void init(void)
{
   theTorus = glGenLists (1);
   glNewList(theTorus, GL_COMPILE);
   torus(8, 25);
   glEndList();

   glShadeModel(GL_FLAT);
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
}

/* Clear window and draw torus */
void display(void)
{
   glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
   glColor3f (1.0, 1.0, 1.0);
   //glCallList(theTorus);
   torus(8, 25);
   glFlush();
   //glutSwapBuffers();
}

/* Handle window resize */
void reshape(int w, int h)
{
   glViewport(0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(30, (GLfloat) w/(GLfloat) h, 1.0, 100.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glTranslatef(0.0f, 0.0f, -10.0f);
   //gluLookAt(0, 0, 10, 0, 0, 0, 0, 1, 0);
}

/* Rotate about x-axis when "x" typed; rotate about y-axis
   when "y" typed; "i" returns torus to original view */
void keyboard()
{
   int key = -1;
   
   if ( gp_getButton()&BUTTON_UP ) {key = UP; glRotatef(30.,0.0,0.1,0.0);}
   if ( gp_getButton()&BUTTON_DOWN ) {key = DOWN; glRotatef(30.,0.0,0.1,0.0);}
   if ( gp_getButton()&BUTTON_LEFT ) {key = LEFT; glRotatef(30.,0.1,0.0,0.0);}
   if ( gp_getButton()&BUTTON_RIGHT ) {key = RIGHT;glRotatef(30.,-0.1,0.0,0.0);}
   if ( gp_getButton()&BUTTON_SELECT ) {key = SELECT; glLoadIdentity(); reshape(240,320);}
      
   /*switch (key) {
   case LEFT:
      glRotatef(30.,0.3,0.0,0.0);
      break;
   case RIGHT:
      glRotatef(30.,-0.3,0.0,0.0);
      break;
   case UP:
      glRotatef(30.,0.0,0.3,0.0);
      break;
   case DOWN:
      glRotatef(30.,0.0,-0.3,0.0);
      break;
   case SELECT:
      glLoadIdentity();
      reshape(240,320);
      //gluLookAt(0, 0, 10, 0, 0, 0, 0, 1, 0);
      //glutPostRedisplay();
      break;
   }*/
}

//void
//mousePress(int button, int state, int x, int y)
//{
//	exit(0);
//}


int                                                                                           
//WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
main (int argc, char **argv)
{

	//glutInitWindowSize(320, 240);
	//glutInit(&num, &argv);
	//glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	//glutCreateWindow("MyApp");
	//glutKeyboardFunc(keyboard);
	//glutDisplayFunc(display);
	//glutMouseFunc(mousePress);
	//glutMainLoop();

	// Our infamous counter
        int contador = 0;

        // The twin framebuffers
        screen = (u16*) FRAMEBUFFER1;
        screen2 = (u16*) FRAMEBUFFER2;

        // This is tough, we need all the power we can get
        gp_setCpuspeed(133);
        gp_initFramebuffer(screen2,16,85);
        gp_initFramebuffer(screen,16,85);

        // "How do you do Mrs.Klimt?" ;-)
        klCreateDefaultContext();
        klSetBufferSize(240, 320);
        klSetColorBuffer(screen2);

	// GL initialization
	init();
	reshape(240,320);
        
	// Tweaking
        //klTweak(KL_TEXTUREMATRIX, GL_FALSE);  // static_cast
        klTweak(KL_TEXTUREMATRIX, 0);
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
        //klTweak(KL_ENABLE_NORMALIZATION, GL_FALSE);
        klTweak(KL_ENABLE_NORMALIZATION, 0);

        // Setting up our initial framebuffer
        gp_setFramebuffer(screen,1);

        // We set up our Real Time Clock
        gp_initRTC();

        // For the FPS count
        r = 0;
        fps = 0;

	while(1){
                display();

                // The FPS stuff
                r = gp_getRTC();

                // If less than a second has passed, increase the number of frames
                if ( r < 64 ) {
                        fps++;
                } else {
                        // We reset the count
                        gp_clearRTC();
                        sprintf(text_fps, "%d", fps);
                        fps = 0;
                }

                if ( contador == 0 ) {
                        contador = 1;
                        if (color_correction == 1) {
                                torgb555(screen2);
                                gp_drawString(300,20,2,"CC",0xFFC0,screen2);
                        }
                        gp_drawString(300,10,3,text_fps,0xFFC0,screen2);
                        gp_setFramebuffer(screen2,1);
                        klSetColorBuffer(screen);
                } else {
                        contador = 0;
                        if (color_correction == 1) {
                                torgb555(screen);
                                gp_drawString(300,20,2,"CC",0xFFC0,screen);
                        }
                        gp_drawString(300,10,3,text_fps,0xFFC0,screen);
                        gp_setFramebuffer(screen,1);
                        klSetColorBuffer(screen2);
                }

                if ( gp_getButton()&BUTTON_A ) gp_Reset();
                if ( gp_getButton()&BUTTON_B ) toggleColorCorrection();
		keyboard();
        }

        return 0;
	
}
